VTK: vtkWebGPURenderWindow Class Reference

| VTK 9.3.1

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkWebGPURenderWindow Class Referenceabstract

`#include <vtkWebGPURenderWindow.h>`

Inheritance diagram for vtkWebGPURenderWindow:
[legend]
Collaboration diagram for vtkWebGPURenderWindow:
[legend]

## Classes
struct | MappingContext
struct | vtkWGPUColorAttachment
struct | vtkWGPUDeptStencil
struct | vtkWGPUFullScreenQuad
struct | vtkWGPUSwapChain
struct | vtkWGPUUserStagingPixelData

## Public Types
typedef vtkRenderWindow | Superclass
Public Types inherited from vtkRenderWindow
typedef vtkWindow | Superclass
Public Types inherited from vtkWindow
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkWebGPURenderWindow * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | SetPowerPreference (bool high=true)
virtual bool | Initialize ()=0
| Concrete render windows must create a platform window and initialize this->WindowId. More...
virtual void | CreateAWindow ()=0
| Create a not-off-screen window. More...
virtual void | DestroyWindow ()=0
| Destroy a not-off-screen window. More...
void | Start () override
| Start the rendering process for a frame. More...
void | End () override
| Update the system, if needed, at end of render process. More...
void | Render () override
| Handle opengl specific code and calls superclass. More...
void | StereoMidpoint () override
| Intermediate method performs operations required between the rendering of the left and right eye. More...
void | Frame () override
| A termination method performed at the end of the rendering process to do things like swapping buffers (if necessary) or similar actions. More...
const char * | GetRenderingBackend () override
| What rendering backend has the user requested. More...
void | ReadPixels ()
| Reads pixels into the `CachedPixelBytes` variable. More...
int | GetColorBufferSizes (int *rgba) override
| Get the size of the color buffer. More...
void | WaitForCompletion () override
| Block the thread until work queue completes all submitted work. More...
int | SupportsOpenGL () override
| Does this render window support OpenGL? 0-false, 1-true. More...
const char * | ReportCapabilities () override
| Get report of capabilities for the render window. More...
bool | InitializeFromCurrentContext () override
| Initialize the render window from the information associated with the currently activated OpenGL context. More...
void | ReleaseGraphicsResources (vtkWindow *) override
| Free up any graphics resources associated with this window a value of NULL means the context may already be destroyed. More...
wgpu::RenderPassEncoder | NewRenderPass (wgpu::RenderPassDescriptor &descriptor)
wgpu::RenderBundleEncoder | NewRenderBundleEncoder (wgpu::RenderBundleEncoderDescriptor &descriptor)
wgpu::CommandEncoder | GetCommandEncoder ()
wgpu::TextureView | GetOffscreenColorAttachmentView ()
wgpu::TextureView | GetDepthStencilView ()
wgpu::TextureFormat | GetDepthStencilFormat ()
bool | HasStencil ()
wgpu::Device | GetDevice ()
wgpu::TextureFormat | GetPreferredSwapChainTextureFormat ()
unsigned char * | GetPixelData (int x, int y, int x2, int y2, int front, int right) override
| Set/Get the pixel data of an image, transmitted as RGBRGB... More...
int | GetPixelData (int x, int y, int x2, int y2, int front, vtkUnsignedCharArray *data, int right) override
| Set/Get the pixel data of an image, transmitted as RGBRGB... More...
int | SetPixelData (int x, int y, int x2, int y2, unsigned char *data, int front, int right) override
| Set/Get the pixel data of an image, transmitted as RGBRGB... More...
int | SetPixelData (int x, int y, int x2, int y2, vtkUnsignedCharArray *data, int front, int right) override
| Set/Get the pixel data of an image, transmitted as RGBRGB... More...
float * | GetRGBAPixelData (int x, int y, int x2, int y2, int front, int right=0) override
| Set/Get the pixel data of an image, transmitted as RGBARGBA... More...
int | GetRGBAPixelData (int x, int y, int x2, int y2, int front, vtkFloatArray *data, int right=0) override
| Set/Get the pixel data of an image, transmitted as RGBARGBA... More...
int | SetRGBAPixelData (int x, int y, int x2, int y2, float *data, int front, int blend=0, int right=0) override
| Set/Get the pixel data of an image, transmitted as RGBARGBA... More...
int | SetRGBAPixelData (int x, int y, int x2, int y2, vtkFloatArray *data, int front, int blend=0, int right=0) override
| Set/Get the pixel data of an image, transmitted as RGBARGBA... More...
void | ReleaseRGBAPixelData (float *data) override
| Set/Get the pixel data of an image, transmitted as RGBARGBA... More...
unsigned char * | GetRGBACharPixelData (int x, int y, int x2, int y2, int front, int right=0) override
| Set/Get the pixel data of an image, transmitted as RGBARGBA... More...
int | GetRGBACharPixelData (int x, int y, int x2, int y2, int front, vtkUnsignedCharArray *data, int right=0) override
| Set/Get the pixel data of an image, transmitted as RGBARGBA... More...
int | SetRGBACharPixelData (int x, int y, int x2, int y2, unsigned char *data, int front, int blend=0, int right=0) override
| Set/Get the pixel data of an image, transmitted as RGBARGBA... More...
int | SetRGBACharPixelData (int x, int y, int x2, int y2, vtkUnsignedCharArray *data, int front, int blend=0, int right=0) override
| Set/Get the pixel data of an image, transmitted as RGBARGBA... More...
float * | GetZbufferData (int x1, int y1, int x2, int y2) override
| Set/Get the zbuffer data from an image. More...
int | GetZbufferData (int x1, int y1, int x2, int y2, float *z) override
| Set/Get the zbuffer data from an image. More...
int | GetZbufferData (int x1, int y1, int x2, int y2, vtkFloatArray *buffer) override
| Set/Get the zbuffer data from an image. More...
int | SetZbufferData (int x1, int y1, int x2, int y2, float *buffer) override
| Set/Get the zbuffer data from an image. More...
int | SetZbufferData (int x1, int y1, int x2, int y2, vtkFloatArray *buffer) override
| Set/Get the zbuffer data from an image. More...
Public Member Functions inherited from vtkRenderWindow
vtkRenderWindow * | NewInstance () const
virtual void | AddRenderer (vtkRenderer *)
| Add a renderer to the list of renderers. More...
void | RemoveRenderer (vtkRenderer *)
| Remove a renderer from the list of renderers. More...
vtkTypeBool | HasRenderer (vtkRenderer *)
| Query if a renderer is in the list of renderers. More...
| vtkGetNewMacro (RenderTimer, vtkRenderTimerLog)
| Get the render timer log for this window. More...
vtkRendererCollection * | GetRenderers ()
| Return the collection of renderers in the render window. More...
void | CaptureGL2PSSpecialProps (vtkCollection *specialProps)
| The GL2PS exporter must handle certain props in a special way (e.g. More...
virtual void | Finalize ()
| Finalize the rendering process. More...
virtual void | CopyResultFrame ()
| Performed at the end of the rendering process to generate image. More...
virtual vtkRenderWindowInteractor * | MakeRenderWindowInteractor ()
| Create an interactor to control renderers in this window. More...
virtual void | StereoUpdate ()
| Update the system, if needed, due to stereo rendering. More...
virtual void | StereoRenderComplete ()
| Handles work required once both views have been rendered when using stereo rendering. More...
virtual void | WindowRemap ()
| Remap the rendering window. More...
virtual vtkTypeBool | GetEventPending ()
| Check to see if a mouse button has been pressed. More...
virtual int | CheckInRenderStatus ()
| Are we rendering at the moment. More...
virtual void | ClearInRenderStatus ()
| Clear status (after an exception was thrown for example) More...
virtual void | SetInteractor (vtkRenderWindowInteractor *)
| Set the interactor to the render window. More...
void | UnRegister (vtkObjectBase *o) override
| This Method detects loops of RenderWindow<->Interactor, so objects are freed properly. More...
virtual bool | IsCurrent ()
| Tells if this window is the current graphics context for the calling thread. More...
virtual void | SetForceMakeCurrent ()
| If called, allow MakeCurrent() to skip cache-check when called. More...
virtual vtkTypeBool | IsDirect ()
| Is this render window using hardware acceleration? 0-false, 1-true. More...
virtual int | GetDepthBufferSize ()
| This method should be defined by the subclass. More...
virtual int | GetNumberOfDevices ()
| Returns the number of devices (graphics cards) on a system. More...
virtual void | GetPhysicalToWorldMatrix (vtkMatrix4x4 *matrix)
| Get physical to world transform matrix. More...
virtual bool | GetDeviceToWorldMatrixForDevice (vtkEventDataDevice device, vtkMatrix4x4 *deviceToWorldMatrix)
| Store in `deviceToWorldMatrix` the matrix that goes from device coordinates to world coordinates. More...
virtual int | GetCapturingGL2PSSpecialProps ()
| Returns true if the render process is capturing text actors. More...
virtual void | HideCursor ()
| Hide or Show the mouse cursor, it is nice to be able to hide the default cursor if you want VTK to display a 3D cursor instead. More...
virtual void | ShowCursor ()
| Hide or Show the mouse cursor, it is nice to be able to hide the default cursor if you want VTK to display a 3D cursor instead. More...
virtual void | SetCursorPosition (int, int)
| Hide or Show the mouse cursor, it is nice to be able to hide the default cursor if you want VTK to display a 3D cursor instead. More...
virtual void | SetCurrentCursor (int)
| Change the shape of the cursor. More...
virtual int | GetCurrentCursor ()
| Change the shape of the cursor. More...
| vtkSetFilePathMacro (CursorFileName)
| Set/Get the full path to the custom cursor. More...
| vtkGetFilePathMacro (CursorFileName)
| Set/Get the full path to the custom cursor. More...
virtual void | SetFullScreen (vtkTypeBool)
| Turn on/off rendering full screen window size. More...
virtual vtkTypeBool | GetFullScreen ()
| Turn on/off rendering full screen window size. More...
virtual void | FullScreenOn ()
| Turn on/off rendering full screen window size. More...
virtual void | FullScreenOff ()
| Turn on/off rendering full screen window size. More...
virtual void | SetBorders (vtkTypeBool)
| Turn on/off window manager borders. More...
virtual vtkTypeBool | GetBorders ()
| Turn on/off window manager borders. More...
virtual void | BordersOn ()
| Turn on/off window manager borders. More...
virtual void | BordersOff ()
| Turn on/off window manager borders. More...
virtual vtkTypeBool | GetStereoCapableWindow ()
| Prescribe that the window be created in a stereo-capable mode. More...
virtual void | StereoCapableWindowOn ()
| Prescribe that the window be created in a stereo-capable mode. More...
virtual void | StereoCapableWindowOff ()
| Prescribe that the window be created in a stereo-capable mode. More...
virtual void | SetStereoCapableWindow (vtkTypeBool capable)
| Prescribe that the window be created in a stereo-capable mode. More...
virtual vtkTypeBool | GetStereoRender ()
| Turn on/off stereo rendering. More...
void | SetStereoRender (vtkTypeBool stereo)
| Turn on/off stereo rendering. More...
virtual void | StereoRenderOn ()
| Turn on/off stereo rendering. More...
virtual void | StereoRenderOff ()
| Turn on/off stereo rendering. More...
virtual void | SetAlphaBitPlanes (vtkTypeBool)
| Turn on/off the use of alpha bitplanes. More...
virtual vtkTypeBool | GetAlphaBitPlanes ()
| Turn on/off the use of alpha bitplanes. More...
virtual void | AlphaBitPlanesOn ()
| Turn on/off the use of alpha bitplanes. More...
virtual void | AlphaBitPlanesOff ()
| Turn on/off the use of alpha bitplanes. More...
virtual void | SetPointSmoothing (vtkTypeBool)
| Turn on/off point smoothing. More...
virtual vtkTypeBool | GetPointSmoothing ()
| Turn on/off point smoothing. More...
virtual void | PointSmoothingOn ()
| Turn on/off point smoothing. More...
virtual void | PointSmoothingOff ()
| Turn on/off point smoothing. More...
virtual void | SetLineSmoothing (vtkTypeBool)
| Turn on/off line smoothing. More...
virtual vtkTypeBool | GetLineSmoothing ()
| Turn on/off line smoothing. More...
virtual void | LineSmoothingOn ()
| Turn on/off line smoothing. More...
virtual void | LineSmoothingOff ()
| Turn on/off line smoothing. More...
virtual void | SetPolygonSmoothing (vtkTypeBool)
| Turn on/off polygon smoothing. More...
virtual vtkTypeBool | GetPolygonSmoothing ()
| Turn on/off polygon smoothing. More...
virtual void | PolygonSmoothingOn ()
| Turn on/off polygon smoothing. More...
virtual void | PolygonSmoothingOff ()
| Turn on/off polygon smoothing. More...
virtual int | GetStereoType ()
| Set/Get what type of stereo rendering to use. More...
void | SetStereoType (int)
| Set/Get what type of stereo rendering to use. More...
void | SetStereoTypeToCrystalEyes ()
| Set/Get what type of stereo rendering to use. More...
void | SetStereoTypeToRedBlue ()
| Set/Get what type of stereo rendering to use. More...
void | SetStereoTypeToInterlaced ()
| Set/Get what type of stereo rendering to use. More...
void | SetStereoTypeToLeft ()
| Set/Get what type of stereo rendering to use. More...
void | SetStereoTypeToRight ()
| Set/Get what type of stereo rendering to use. More...
void | SetStereoTypeToDresden ()
| Set/Get what type of stereo rendering to use. More...
void | SetStereoTypeToAnaglyph ()
| Set/Get what type of stereo rendering to use. More...
void | SetStereoTypeToCheckerboard ()
| Set/Get what type of stereo rendering to use. More...
void | SetStereoTypeToSplitViewportHorizontal ()
| Set/Get what type of stereo rendering to use. More...
void | SetStereoTypeToFake ()
| Set/Get what type of stereo rendering to use. More...
void | SetStereoTypeToEmulate ()
| Set/Get what type of stereo rendering to use. More...
virtual void | SetAnaglyphColorSaturation (float)
| Set/get the anaglyph color saturation factor. More...
virtual float | GetAnaglyphColorSaturation ()
| Set/get the anaglyph color saturation factor. More...
virtual void | SetAnaglyphColorMask (int, int)
| Set/get the anaglyph color mask values. More...
void | SetAnaglyphColorMask (int[2])
| Set/get the anaglyph color mask values. More...
virtual int * | GetAnaglyphColorMask ()
| Set/get the anaglyph color mask values. More...
virtual void | GetAnaglyphColorMask (int data[2])
| Set/get the anaglyph color mask values. More...
virtual void | SetSwapBuffers (vtkTypeBool)
| Turn on/off buffer swapping between images. More...
virtual vtkTypeBool | GetSwapBuffers ()
| Turn on/off buffer swapping between images. More...
virtual void | SwapBuffersOn ()
| Turn on/off buffer swapping between images. More...
virtual void | SwapBuffersOff ()
| Turn on/off buffer swapping between images. More...
float | GetZbufferDataAtPoint (int x, int y)
| Set/Get the zbuffer data from the frame buffer. More...
virtual int | GetNeverRendered ()
| This flag is set if the window hasn't rendered since it was created. More...
virtual int | GetAbortRender ()
| This is a flag that can be set to interrupt a rendering that is in progress. More...
virtual void | SetAbortRender (int)
| This is a flag that can be set to interrupt a rendering that is in progress. More...
virtual int | GetInAbortCheck ()
| This is a flag that can be set to interrupt a rendering that is in progress. More...
virtual void | SetInAbortCheck (int)
| This is a flag that can be set to interrupt a rendering that is in progress. More...
virtual int | CheckAbortStatus ()
| This is a flag that can be set to interrupt a rendering that is in progress. More...
virtual void | SetDesiredUpdateRate (double)
| Set/Get the desired update rate. More...
virtual double | GetDesiredUpdateRate ()
| Set/Get the desired update rate. More...
virtual int | GetNumberOfLayers ()
| Get the number of layers for renderers. More...
virtual void | SetNumberOfLayers (int)
| Get the number of layers for renderers. More...
virtual vtkRenderWindowInteractor * | GetInteractor ()
| Get the interactor associated with this render window. More...
void | SetDisplayId (void *) override
| Dummy stubs for vtkWindow API. More...
void | SetWindowId (void *) override
| Dummy stubs for vtkWindow API. More...
virtual void | SetNextWindowId (void *)
| Dummy stubs for vtkWindow API. More...
void | SetParentId (void *) override
| Dummy stubs for vtkWindow API. More...
void * | GetGenericDisplayId () override
| Dummy stubs for vtkWindow API. More...
void * | GetGenericWindowId () override
| Dummy stubs for vtkWindow API. More...
void * | GetGenericParentId () override
| Dummy stubs for vtkWindow API. More...
void * | GetGenericContext () override
| Dummy stubs for vtkWindow API. More...
void * | GetGenericDrawable () override
| Dummy stubs for vtkWindow API. More...
void | SetWindowInfo (const char *) override
| Dummy stubs for vtkWindow API. More...
virtual void | SetNextWindowInfo (const char *)
| Dummy stubs for vtkWindow API. More...
void | SetParentInfo (const char *) override
| Dummy stubs for vtkWindow API. More...
virtual void | SetSharedRenderWindow (vtkRenderWindow *)
| Set/Get an already existing window that this window should share data with if possible. More...
virtual vtkRenderWindow * | GetSharedRenderWindow ()
| Set/Get an already existing window that this window should share data with if possible. More...
virtual bool | GetPlatformSupportsRenderWindowSharing ()
| Set/Get an already existing window that this window should share data with if possible. More...
virtual void | SetMultiSamples (int)
| Set / Get the number of multisamples to use for hardware antialiasing. More...
virtual int | GetMultiSamples ()
| Set / Get the number of multisamples to use for hardware antialiasing. More...
virtual void | SetStencilCapable (vtkTypeBool)
| Set / Get the availability of the stencil buffer. More...
virtual vtkTypeBool | GetStencilCapable ()
| Set / Get the availability of the stencil buffer. More...
virtual void | StencilCapableOn ()
| Set / Get the availability of the stencil buffer. More...
virtual void | StencilCapableOff ()
| Set / Get the availability of the stencil buffer. More...
virtual void | SetDeviceIndex (int)
| If there are several graphics card installed on a system, this index can be used to specify which card you want to render to. More...
virtual int | GetDeviceIndex ()
| If there are several graphics card installed on a system, this index can be used to specify which card you want to render to. More...
virtual bool | GetUseSRGBColorSpace ()
| Set/Get if we want this window to use the sRGB color space. More...
virtual void | SetUseSRGBColorSpace (bool)
| Set/Get if we want this window to use the sRGB color space. More...
virtual void | UseSRGBColorSpaceOn ()
| Set/Get if we want this window to use the sRGB color space. More...
virtual void | UseSRGBColorSpaceOff ()
| Set/Get if we want this window to use the sRGB color space. More...
const char * | GetStereoTypeAsString ()
| Returns the stereo type as a string. More...
Public Member Functions inherited from vtkWindow
vtkWindow * | NewInstance () const
int * | GetActualSize ()
| GetSize() returns the size * this->TileScale, whereas this method returns the size without multiplying with the tile scale. More...
virtual int * | GetScreenSize ()
| Get the current size of the screen in pixels. More...
virtual void | SetIcon (vtkImageData *)
| Set the icon used in title bar and task bar. More...
virtual bool | DetectDPI ()
| Attempt to detect and set the DPI of the display device by querying the system. More...
vtkTypeBool | GetOffScreenRendering ()
| Deprecated, directly use GetShowWindow and GetOffScreenBuffers instead. More...
virtual void | MakeCurrent ()
| Make the window current. More...
virtual void | ReleaseCurrent ()
| Release the current context. More...
virtual int * | GetPosition ()
| Get the position (x and y) of the rendering window in screen coordinates (in pixels). More...
virtual void | SetPosition (int x, int y)
| Set the position (x and y) of the rendering window in screen coordinates (in pixels). More...
virtual void | SetPosition (int a[2])
| Get the position (x and y) of the rendering window in screen coordinates (in pixels). More...
virtual int * | GetSize ()
| Get the size (width and height) of the rendering window in screen coordinates (in pixels). More...
virtual void | SetSize (int width, int height)
| Set the size (width and height) of the rendering window in screen coordinates (in pixels). More...
virtual void | SetSize (int a[2])
| Get the size (width and height) of the rendering window in screen coordinates (in pixels). More...
virtual vtkTypeBool | GetMapped ()
| Keep track of whether the rendering window has been mapped to screen. More...
virtual bool | GetShowWindow ()
| Show or not Show the window. More...
virtual void | SetShowWindow (bool)
| Show or not Show the window. More...
virtual void | ShowWindowOn ()
| Show or not Show the window. More...
virtual void | ShowWindowOff ()
| Show or not Show the window. More...
virtual void | SetUseOffScreenBuffers (bool)
| Render to an offscreen destination such as a framebuffer. More...
virtual bool | GetUseOffScreenBuffers ()
| Render to an offscreen destination such as a framebuffer. More...
virtual void | UseOffScreenBuffersOn ()
| Render to an offscreen destination such as a framebuffer. More...
virtual void | UseOffScreenBuffersOff ()
| Render to an offscreen destination such as a framebuffer. More...
virtual void | SetErase (vtkTypeBool)
| Turn on/off erasing the screen between images. More...
virtual vtkTypeBool | GetErase ()
| Turn on/off erasing the screen between images. More...
virtual void | EraseOn ()
| Turn on/off erasing the screen between images. More...
virtual void | EraseOff ()
| Turn on/off erasing the screen between images. More...
virtual void | SetDoubleBuffer (vtkTypeBool)
| Keep track of whether double buffering is on or off. More...
virtual vtkTypeBool | GetDoubleBuffer ()
| Keep track of whether double buffering is on or off. More...
virtual void | DoubleBufferOn ()
| Keep track of whether double buffering is on or off. More...
virtual void | DoubleBufferOff ()
| Keep track of whether double buffering is on or off. More...
virtual char * | GetWindowName ()
| Get name of rendering window. More...
virtual void | SetWindowName (const char *)
| Get name of rendering window. More...
virtual int | GetDPI ()
| Return a best estimate to the dots per inch of the display device being rendered (or printed). More...
virtual void | SetDPI (int)
| Return a best estimate to the dots per inch of the display device being rendered (or printed). More...
void | SetOffScreenRendering (vtkTypeBool val)
| Convenience to set SHowWindow and UseOffScreenBuffers in one call. More...
virtual void | OffScreenRenderingOn ()
| Convenience to set SHowWindow and UseOffScreenBuffers in one call. More...
virtual void | OffScreenRenderingOff ()
| Convenience to set SHowWindow and UseOffScreenBuffers in one call. More...
virtual void | SetTileScale (int, int)
| These methods are used by vtkWindowToImageFilter to tell a VTK window to simulate a larger window by tiling. More...
void | SetTileScale (int[2])
| These methods are used by vtkWindowToImageFilter to tell a VTK window to simulate a larger window by tiling. More...
virtual int * | GetTileScale ()
| These methods are used by vtkWindowToImageFilter to tell a VTK window to simulate a larger window by tiling. More...
virtual void | GetTileScale (int &, int &)
| These methods are used by vtkWindowToImageFilter to tell a VTK window to simulate a larger window by tiling. More...
virtual void | GetTileScale (int[2])
| These methods are used by vtkWindowToImageFilter to tell a VTK window to simulate a larger window by tiling. More...
void | SetTileScale (int s)
| These methods are used by vtkWindowToImageFilter to tell a VTK window to simulate a larger window by tiling. More...
virtual void | SetTileViewport (double, double, double, double)
| These methods are used by vtkWindowToImageFilter to tell a VTK window to simulate a larger window by tiling. More...
virtual void | SetTileViewport (double[4])
| These methods are used by vtkWindowToImageFilter to tell a VTK window to simulate a larger window by tiling. More...
virtual double * | GetTileViewport ()
| These methods are used by vtkWindowToImageFilter to tell a VTK window to simulate a larger window by tiling. More...
virtual void | GetTileViewport (double &, double &, double &, double &)
| These methods are used by vtkWindowToImageFilter to tell a VTK window to simulate a larger window by tiling. More...
virtual void | GetTileViewport (double[4])
| These methods are used by vtkWindowToImageFilter to tell a VTK window to simulate a larger window by tiling. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkWebGPURenderWindow * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkRenderWindow
static vtkTypeBool | IsTypeOf (const char *type)
static vtkRenderWindow * | SafeDownCast (vtkObjectBase *o)
static vtkRenderWindow * | New ()
| Construct an instance of vtkRenderWindow with its screen size set to 300x300, borders turned on, positioned at (0,0), double buffering turned on. More...
static const char * | GetRenderLibrary ()
| What rendering library has the user requested. More...
static const char * | GetStereoTypeAsString (int type)
| Returns the stereo type as a string. More...
Static Public Member Functions inherited from vtkWindow
static vtkTypeBool | IsTypeOf (const char *type)
static vtkWindow * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkWebGPURenderWindow ()
| ~vtkWebGPURenderWindow () override
bool | WGPUInit ()
void | WGPUFinalize ()
void | CreateSwapChain ()
void | DestroySwapChain ()
void | CreateOffscreenColorAttachments ()
void | DestroyOffscreenColorAttachments ()
void | CreateDepthStencilTexture ()
void | DestroyDepthStencilTexture ()
void | CreateFSQGraphicsPipeline ()
void | DestroyFSQGraphicsPipeline ()
void | RenderOffscreenTexture ()
void | FlushCommandBuffers (vtkTypeUInt32 count, wgpu::CommandBuffer *buffers)
Protected Member Functions inherited from vtkRenderWindow
| vtkRenderWindow ()
| ~vtkRenderWindow () override
virtual void | DoStereoRender ()
Protected Member Functions inherited from vtkWindow
| vtkWindow ()
| ~vtkWindow () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
bool | WGPUInitialized = false
wgpu::PowerPreference | PowerPreference = wgpu::PowerPreference::HighPerformance
wgpu::Adapter | Adapter
wgpu::Device | Device
wgpu::Surface | Surface
wgpu::CommandEncoder | CommandEncoder
vtkWGPUSwapChain | SwapChain
vtkWGPUDeptStencil | DepthStencil
vtkWGPUColorAttachment | ColorAttachment
vtkWGPUUserStagingPixelData | StagingPixelData
vtkWGPUFullScreenQuad | FSQ
struct vtkWebGPURenderWindow::MappingContext | BufferMapReadContext
vtkNew< vtkTypeUInt8Array > | CachedPixelBytes
Protected Attributes inherited from vtkRenderWindow
vtkRendererCollection * | Renderers
vtkNew< vtkRenderTimerLog > | RenderTimer
vtkTypeBool | Borders
vtkTypeBool | FullScreen
int | OldScreen [5]
vtkTypeBool | PointSmoothing
vtkTypeBool | LineSmoothing
vtkTypeBool | PolygonSmoothing
vtkTypeBool | StereoRender
int | StereoType
vtkTypeBool | StereoCapableWindow
vtkTypeBool | AlphaBitPlanes
vtkRenderWindowInteractor * | Interactor
vtkSmartPointer< vtkUnsignedCharArray > | StereoBuffer
vtkSmartPointer< vtkUnsignedCharArray > | ResultFrame
vtkTypeBool | SwapBuffers
double | DesiredUpdateRate
int | AbortRender
int | InAbortCheck
int | InRender
int | NeverRendered
int | NumberOfLayers
int | CurrentCursor
float | AnaglyphColorSaturation
int | AnaglyphColorMask [2]
int | MultiSamples
vtkTypeBool | StencilCapable
int | CapturingGL2PSSpecialProps
int | DeviceIndex
bool | UseSRGBColorSpace
char * | CursorFileName
double | AbortCheckTime
| The universal time since the last abort check occurred. More...
vtkRenderWindow * | SharedRenderWindow
Protected Attributes inherited from vtkWindow
char * | WindowName
int | Size [2]
int | Position [2]
vtkTypeBool | Mapped
bool | ShowWindow
bool | UseOffScreenBuffers
vtkTypeBool | Erase
vtkTypeBool | DoubleBuffer
int | DPI
double | TileViewport [4]
int | TileSize [2]
int | TileScale [2]
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

Definition at line 14 of file vtkWebGPURenderWindow.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkRenderWindow vtkWebGPURenderWindow::Superclass

Definition at line 17 of file vtkWebGPURenderWindow.h.

## Constructor & Destructor Documentation

## ◆ vtkWebGPURenderWindow()

vtkWebGPURenderWindow::vtkWebGPURenderWindow | ( |  | ) |
| protected

## ◆ ~vtkWebGPURenderWindow()

vtkWebGPURenderWindow::~vtkWebGPURenderWindow | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkWebGPURenderWindow::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkWebGPURenderWindow::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkRenderWindow.

Reimplemented in vtkSDL2WebGPURenderWindow.

## ◆ SafeDownCast()

static vtkWebGPURenderWindow* vtkWebGPURenderWindow::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkWebGPURenderWindow::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkRenderWindow.

Reimplemented in vtkSDL2WebGPURenderWindow.

## ◆ NewInstance()

vtkWebGPURenderWindow* vtkWebGPURenderWindow::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkWebGPURenderWindow::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkRenderWindow.

## ◆ SetPowerPreference()

void vtkWebGPURenderWindow::SetPowerPreference | ( | bool | high = `true` | ) |
| inline

Definition at line 21 of file vtkWebGPURenderWindow.h.

## ◆ Initialize()

virtual bool vtkWebGPURenderWindow::Initialize | ( |  | ) |
| pure virtual

Concrete render windows must create a platform window and initialize this->WindowId.

Upon success, please call WGPUInit().

Implemented in vtkSDL2WebGPURenderWindow.

## ◆ CreateAWindow()

virtual void vtkWebGPURenderWindow::CreateAWindow | ( |  | ) |
| pure virtual

Create a not-off-screen window.

Implemented in vtkSDL2WebGPURenderWindow.

## ◆ DestroyWindow()

virtual void vtkWebGPURenderWindow::DestroyWindow | ( |  | ) |
| pure virtual

Destroy a not-off-screen window.

Implemented in vtkSDL2WebGPURenderWindow.

## ◆ Start()

void vtkWebGPURenderWindow::Start | ( |  | ) |
| overridevirtual

Start the rendering process for a frame.

Reimplemented from vtkRenderWindow.

## ◆ End()

void vtkWebGPURenderWindow::End | ( |  | ) |
| overridevirtual

Update the system, if needed, at end of render process.

Reimplemented from vtkRenderWindow.

## ◆ Render()

void vtkWebGPURenderWindow::Render | ( |  | ) |
| overridevirtual

Handle opengl specific code and calls superclass.

Reimplemented from vtkRenderWindow.

## ◆ StereoMidpoint()

void vtkWebGPURenderWindow::StereoMidpoint | ( |  | ) |
| overridevirtual

Intermediate method performs operations required between the rendering of the left and right eye.

Reimplemented from vtkRenderWindow.

## ◆ Frame()

void vtkWebGPURenderWindow::Frame | ( |  | ) |
| overridevirtual

A termination method performed at the end of the rendering process to do things like swapping buffers (if necessary) or similar actions.

Reimplemented from vtkRenderWindow.

## ◆ GetRenderingBackend()

const char* vtkWebGPURenderWindow::GetRenderingBackend | ( |  | ) |
| overridevirtual

What rendering backend has the user requested.

Reimplemented from vtkRenderWindow.

## ◆ ReadPixels()

void vtkWebGPURenderWindow::ReadPixels | ( |  | ) |

Reads pixels into the `CachedPixelBytes` variable.

## ◆ GetPixelData() [1/2]

unsigned char* vtkWebGPURenderWindow::GetPixelData | ( | int | x,
|  | int | y,
|  | int | x2,
|  | int | y2,
|  | int | front,
|  | int | right
| ) |  |
| overridevirtual

Set/Get the pixel data of an image, transmitted as RGBRGB...

front in this context indicates that the read should come from the display buffer versus the render buffer

Reimplemented from vtkWindow.

## ◆ GetPixelData() [2/2]

int vtkWebGPURenderWindow::GetPixelData | ( | int | x,
|  | int | y,
|  | int | x2,
|  | int | y2,
|  | int | front,
|  | vtkUnsignedCharArray * | data,
|  | int | right
| ) |  |
| overridevirtual

Set/Get the pixel data of an image, transmitted as RGBRGB...

front in this context indicates that the read should come from the display buffer versus the render buffer

Reimplemented from vtkWindow.

## ◆ SetPixelData() [1/2]

int vtkWebGPURenderWindow::SetPixelData | ( | int | x,
|  | int | y,
|  | int | x2,
|  | int | y2,
|  | unsigned char * | data,
|  | int | front,
|  | int | right
| ) |  |
| overridevirtual

Set/Get the pixel data of an image, transmitted as RGBRGB...

front in this context indicates that the read should come from the display buffer versus the render buffer

Reimplemented from vtkRenderWindow.

## ◆ SetPixelData() [2/2]

int vtkWebGPURenderWindow::SetPixelData | ( | int | x,
|  | int | y,
|  | int | x2,
|  | int | y2,
|  | vtkUnsignedCharArray * | data,
|  | int | front,
|  | int | right
| ) |  |
| overridevirtual

Set/Get the pixel data of an image, transmitted as RGBRGB...

front in this context indicates that the read should come from the display buffer versus the render buffer

Reimplemented from vtkRenderWindow.

## ◆ GetRGBAPixelData() [1/2]

float* vtkWebGPURenderWindow::GetRGBAPixelData | ( | int | x,
|  | int | y,
|  | int | x2,
|  | int | y2,
|  | int | front,
|  | int | right = `0`
| ) |  |
| overridevirtual

Set/Get the pixel data of an image, transmitted as RGBARGBA...

Reimplemented from vtkRenderWindow.

## ◆ GetRGBAPixelData() [2/2]

int vtkWebGPURenderWindow::GetRGBAPixelData | ( | int | x,
|  | int | y,
|  | int | x2,
|  | int | y2,
|  | int | front,
|  | vtkFloatArray * | data,
|  | int | right = `0`
| ) |  |
| overridevirtual

Set/Get the pixel data of an image, transmitted as RGBARGBA...

Reimplemented from vtkRenderWindow.

## ◆ SetRGBAPixelData() [1/2]

int vtkWebGPURenderWindow::SetRGBAPixelData | ( | int | x,
|  | int | y,
|  | int | x2,
|  | int | y2,
|  | float * | data,
|  | int | front,
|  | int | blend = `0`,
|  | int | right = `0`
| ) |  |
| overridevirtual

Set/Get the pixel data of an image, transmitted as RGBARGBA...

Reimplemented from vtkRenderWindow.

## ◆ SetRGBAPixelData() [2/2]

int vtkWebGPURenderWindow::SetRGBAPixelData | ( | int | x,
|  | int | y,
|  | int | x2,
|  | int | y2,
|  | vtkFloatArray * | data,
|  | int | front,
|  | int | blend = `0`,
|  | int | right = `0`
| ) |  |
| overridevirtual

Set/Get the pixel data of an image, transmitted as RGBARGBA...

Reimplemented from vtkRenderWindow.

## ◆ ReleaseRGBAPixelData()

void vtkWebGPURenderWindow::ReleaseRGBAPixelData | ( | float * | data | ) |
| overridevirtual

Set/Get the pixel data of an image, transmitted as RGBARGBA...

Reimplemented from vtkRenderWindow.

## ◆ GetRGBACharPixelData() [1/2]

unsigned char* vtkWebGPURenderWindow::GetRGBACharPixelData | ( | int | x,
|  | int | y,
|  | int | x2,
|  | int | y2,
|  | int | front,
|  | int | right = `0`
| ) |  |
| overridevirtual

Set/Get the pixel data of an image, transmitted as RGBARGBA...

Reimplemented from vtkRenderWindow.

## ◆ GetRGBACharPixelData() [2/2]

int vtkWebGPURenderWindow::GetRGBACharPixelData | ( | int | x,
|  | int | y,
|  | int | x2,
|  | int | y2,
|  | int | front,
|  | vtkUnsignedCharArray * | data,
|  | int | right = `0`
| ) |  |
| overridevirtual

Set/Get the pixel data of an image, transmitted as RGBARGBA...

Reimplemented from vtkRenderWindow.

## ◆ SetRGBACharPixelData() [1/2]

int vtkWebGPURenderWindow::SetRGBACharPixelData | ( | int | x,
|  | int | y,
|  | int | x2,
|  | int | y2,
|  | unsigned char * | data,
|  | int | front,
|  | int | blend = `0`,
|  | int | right = `0`
| ) |  |
| overridevirtual

Set/Get the pixel data of an image, transmitted as RGBARGBA...

Reimplemented from vtkRenderWindow.

## ◆ SetRGBACharPixelData() [2/2]

int vtkWebGPURenderWindow::SetRGBACharPixelData | ( | int | x,
|  | int | y,
|  | int | x2,
|  | int | y2,
|  | vtkUnsignedCharArray * | data,
|  | int | front,
|  | int | blend = `0`,
|  | int | right = `0`
| ) |  |
| overridevirtual

Set/Get the pixel data of an image, transmitted as RGBARGBA...

Reimplemented from vtkRenderWindow.

## ◆ GetZbufferData() [1/3]

float* vtkWebGPURenderWindow::GetZbufferData | ( | int | x1,
|  | int | y1,
|  | int | x2,
|  | int | y2
| ) |  |
| overridevirtual

Set/Get the zbuffer data from an image.

Reimplemented from vtkRenderWindow.

## ◆ GetZbufferData() [2/3]

int vtkWebGPURenderWindow::GetZbufferData | ( | int | x1,
|  | int | y1,
|  | int | x2,
|  | int | y2,
|  | float * | z
| ) |  |
| overridevirtual

Set/Get the zbuffer data from an image.

Reimplemented from vtkRenderWindow.

## ◆ GetZbufferData() [3/3]

int vtkWebGPURenderWindow::GetZbufferData | ( | int | x1,
|  | int | y1,
|  | int | x2,
|  | int | y2,
|  | vtkFloatArray * | buffer
| ) |  |
| overridevirtual

Set/Get the zbuffer data from an image.

Reimplemented from vtkRenderWindow.

## ◆ SetZbufferData() [1/2]

int vtkWebGPURenderWindow::SetZbufferData | ( | int | x1,
|  | int | y1,
|  | int | x2,
|  | int | y2,
|  | float * | buffer
| ) |  |
| overridevirtual

Set/Get the zbuffer data from an image.

Reimplemented from vtkRenderWindow.

## ◆ SetZbufferData() [2/2]

int vtkWebGPURenderWindow::SetZbufferData | ( | int | x1,
|  | int | y1,
|  | int | x2,
|  | int | y2,
|  | vtkFloatArray * | buffer
| ) |  |
| overridevirtual

Set/Get the zbuffer data from an image.

Reimplemented from vtkRenderWindow.

## ◆ GetColorBufferSizes()

int vtkWebGPURenderWindow::GetColorBufferSizes | ( | int * | rgba | ) |
| overridevirtual

Get the size of the color buffer.

Returns 0 if not able to determine otherwise sets R G B and A into buffer.

Reimplemented from vtkRenderWindow.

## ◆ WaitForCompletion()

void vtkWebGPURenderWindow::WaitForCompletion | ( |  | ) |
| overridevirtual

Block the thread until work queue completes all submitted work.

Reimplemented from vtkRenderWindow.

## ◆ SupportsOpenGL()

int vtkWebGPURenderWindow::SupportsOpenGL | ( |  | ) |
| overridevirtual

Does this render window support OpenGL? 0-false, 1-true.

Reimplemented from vtkRenderWindow.

## ◆ ReportCapabilities()

const char* vtkWebGPURenderWindow::ReportCapabilities | ( |  | ) |
| overridevirtual

Get report of capabilities for the render window.

Reimplemented from vtkRenderWindow.

## ◆ InitializeFromCurrentContext()

bool vtkWebGPURenderWindow::InitializeFromCurrentContext | ( |  | ) |
| overridevirtual

Initialize the render window from the information associated with the currently activated OpenGL context.

Reimplemented from vtkRenderWindow.

## ◆ ReleaseGraphicsResources()

void vtkWebGPURenderWindow::ReleaseGraphicsResources | ( | vtkWindow * |  | ) |
| overridevirtual

Free up any graphics resources associated with this window a value of NULL means the context may already be destroyed.

Reimplemented from vtkWindow.

## ◆ NewRenderPass()

wgpu::RenderPassEncoder vtkWebGPURenderWindow::NewRenderPass | ( | wgpu::RenderPassDescriptor & | descriptor | ) |
| inline

Definition at line 150 of file vtkWebGPURenderWindow.h.

## ◆ NewRenderBundleEncoder()

wgpu::RenderBundleEncoder vtkWebGPURenderWindow::NewRenderBundleEncoder | ( | wgpu::RenderBundleEncoderDescriptor & | descriptor | ) |
| inline

Definition at line 155 of file vtkWebGPURenderWindow.h.

## ◆ GetCommandEncoder()

wgpu::CommandEncoder vtkWebGPURenderWindow::GetCommandEncoder | ( |  | ) |
| inline

Definition at line 161 of file vtkWebGPURenderWindow.h.

## ◆ GetOffscreenColorAttachmentView()

wgpu::TextureView vtkWebGPURenderWindow::GetOffscreenColorAttachmentView | ( |  | ) |
| inline

Definition at line 162 of file vtkWebGPURenderWindow.h.

## ◆ GetDepthStencilView()

wgpu::TextureView vtkWebGPURenderWindow::GetDepthStencilView | ( |  | ) |
| inline

Definition at line 163 of file vtkWebGPURenderWindow.h.

## ◆ GetDepthStencilFormat()

wgpu::TextureFormat vtkWebGPURenderWindow::GetDepthStencilFormat | ( |  | ) |
| inline

Definition at line 164 of file vtkWebGPURenderWindow.h.

## ◆ HasStencil()

bool vtkWebGPURenderWindow::HasStencil | ( |  | ) |
| inline

Definition at line 165 of file vtkWebGPURenderWindow.h.

## ◆ GetDevice()

wgpu::Device vtkWebGPURenderWindow::GetDevice | ( |  | ) |
| inline

Definition at line 166 of file vtkWebGPURenderWindow.h.

## ◆ GetPreferredSwapChainTextureFormat()

wgpu::TextureFormat vtkWebGPURenderWindow::GetPreferredSwapChainTextureFormat | ( |  | ) |

## ◆ WGPUInit()

bool vtkWebGPURenderWindow::WGPUInit | ( |  | ) |
| protected

## ◆ WGPUFinalize()

void vtkWebGPURenderWindow::WGPUFinalize | ( |  | ) |
| protected

## ◆ CreateSwapChain()

void vtkWebGPURenderWindow::CreateSwapChain | ( |  | ) |
| protected

## ◆ DestroySwapChain()

void vtkWebGPURenderWindow::DestroySwapChain | ( |  | ) |
| protected

## ◆ CreateOffscreenColorAttachments()

void vtkWebGPURenderWindow::CreateOffscreenColorAttachments | ( |  | ) |
| protected

## ◆ DestroyOffscreenColorAttachments()

void vtkWebGPURenderWindow::DestroyOffscreenColorAttachments | ( |  | ) |
| protected

## ◆ CreateDepthStencilTexture()

void vtkWebGPURenderWindow::CreateDepthStencilTexture | ( |  | ) |
| protected

## ◆ DestroyDepthStencilTexture()

void vtkWebGPURenderWindow::DestroyDepthStencilTexture | ( |  | ) |
| protected

## ◆ CreateFSQGraphicsPipeline()

void vtkWebGPURenderWindow::CreateFSQGraphicsPipeline | ( |  | ) |
| protected

## ◆ DestroyFSQGraphicsPipeline()

void vtkWebGPURenderWindow::DestroyFSQGraphicsPipeline | ( |  | ) |
| protected

## ◆ RenderOffscreenTexture()

void vtkWebGPURenderWindow::RenderOffscreenTexture | ( |  | ) |
| protected

## ◆ FlushCommandBuffers()

void vtkWebGPURenderWindow::FlushCommandBuffers | ( | vtkTypeUInt32 | count,
|  | wgpu::CommandBuffer * | buffers
| ) |  |
| protected

## Member Data Documentation

## ◆ WGPUInitialized

bool vtkWebGPURenderWindow::WGPUInitialized = false
| protected

Definition at line 193 of file vtkWebGPURenderWindow.h.

## ◆ PowerPreference

wgpu::PowerPreference vtkWebGPURenderWindow::PowerPreference = wgpu::PowerPreference::HighPerformance
| protected

Definition at line 194 of file vtkWebGPURenderWindow.h.

## ◆ Adapter

wgpu::Adapter vtkWebGPURenderWindow::Adapter
| protected

Definition at line 195 of file vtkWebGPURenderWindow.h.

## ◆ Device

wgpu::Device vtkWebGPURenderWindow::Device
| protected

Definition at line 196 of file vtkWebGPURenderWindow.h.

## ◆ Surface

wgpu::Surface vtkWebGPURenderWindow::Surface
| protected

Definition at line 197 of file vtkWebGPURenderWindow.h.

## ◆ CommandEncoder

wgpu::CommandEncoder vtkWebGPURenderWindow::CommandEncoder
| protected

Definition at line 198 of file vtkWebGPURenderWindow.h.

## ◆ SwapChain

vtkWGPUSwapChain vtkWebGPURenderWindow::SwapChain
| protected

Definition at line 209 of file vtkWebGPURenderWindow.h.

## ◆ DepthStencil

vtkWGPUDeptStencil vtkWebGPURenderWindow::DepthStencil
| protected

Definition at line 218 of file vtkWebGPURenderWindow.h.

## ◆ ColorAttachment

vtkWGPUColorAttachment vtkWebGPURenderWindow::ColorAttachment
| protected

Definition at line 227 of file vtkWebGPURenderWindow.h.

## ◆ StagingPixelData

vtkWGPUUserStagingPixelData vtkWebGPURenderWindow::StagingPixelData
| protected

Definition at line 236 of file vtkWebGPURenderWindow.h.

## ◆ FSQ

vtkWGPUFullScreenQuad vtkWebGPURenderWindow::FSQ
| protected

Definition at line 243 of file vtkWebGPURenderWindow.h.

## ◆ BufferMapReadContext

struct vtkWebGPURenderWindow::MappingContext vtkWebGPURenderWindow::BufferMapReadContext
| protected

## ◆ CachedPixelBytes

vtkNew<vtkTypeUInt8Array> vtkWebGPURenderWindow::CachedPixelBytes
| protected

Definition at line 252 of file vtkWebGPURenderWindow.h.

The documentation for this class was generated from the following file:

- Rendering/WebGPU/vtkWebGPURenderWindow.h